/* 
 * Primitives de dessin pour libNDS
 * Auteur : Fares BELHADJ
 * Email  : amsi@ai.univ-paris8.fr
 * Date   : 09/10/2007
*/

#ifndef PRIMITIVES_H

#define PRIMITIVES_H

#include <nds.h>
#include <stdio.h>
#include <stdlib.h>

/* macro pour tester si x et y sont dans limites de l'ecran */
#define inScreen(x, y) ((x) >= 0 && (y) >= 0 && (x) < SCREEN_WIDTH && (y) < SCREEN_HEIGHT)

#define RAD * M_PI / 180.0
#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define MAX(a, b) (((a) > (b)) ? (a) : (b))

typedef struct vertex2i3u_t vertex2i3u_t;

struct vertex2i3u_t {
  int x, y;
  uint8 r, g, b;
};

/* fonctions definies dans primitives.c */

extern uint16 setColor15     (uint16 c);
extern uint16 getColor15     (uint16 c);
extern void   vramaPutPixel  (int x, int y);
extern void   line           (void (* ppfunc)(int x, int y), int x0, int y0, int x1, int y1);
extern void   HLine          (void (* ppfunc)(int x, int y), int x0, int y0, int x1, int y1);
extern void   shadedHLine    (void (* ppfunc)(int x, int y), vertex2i3u_t * p, vertex2i3u_t * q, int y);
extern int    v2i3uAbscisses (vertex2i3u_t * p, vertex2i3u_t * q, vertex2i3u_t * a);
extern void   shadedScanline (void (* ppfunc)(int x, int y), vertex2i3u_t * p, int n);

#endif
