/* 
 * Remplissage de polygone avec libnds et algo de remplissage scanline
 * decrit dans primitives.c 
 * Auteur : Fares BELHADJ 
 * Email :
 * amsi@ai.univ-paris8.fr 
 * Date : 02/10/2007 modifie le 09/10/2007
 */

#include <nds.h>
#include <stdio.h>
#include <stdlib.h>
#include "primitives.h"

static void init(void);
static void draw(void);

/*
 * un tout petit main
 */
int main(void) {
  init();
  while(1) {
    draw();
  }
  return 0;
}

/*
 * Initialiser l'affichage de la console
 */
static void init(void) {
  consoleDemoInit();
  videoSetMode   (MODE_FB0);   /* direct frame buffer */
  vramSetBankA   (VRAM_A_LCD); /* quelle partie de la VRAM utiliser */
  lcdSwap(); /* echanger les deux ecrans d'affichage */
}

/*
 * Dessiner un polygone avec degrade
 * bouger les points a chaque frame
 */
static void draw(void) {
  int i;
  static int dx[] = {-1, 1, 1}, dy[] = {1, -1, 1};
  static vertex2i3u_t p[] = {{10, 10, 31, 0, 0}, 
			     {20, 130, 31, 31, 0}, 
			     {180, 120, 0, 0, 31} };
  shadedScanline(vramaPutPixel, p, 3);
  for(i = 0; i < 3; i++) {
    if(p[i].x == 0 || p[i].x == SCREEN_WIDTH  - 1) dx[i] = -dx[i];
    if(p[i].y == 0 || p[i].y == SCREEN_HEIGHT - 1) dy[i] = -dy[i];
    p[i].x += dx[i];
    p[i].y += dy[i];
  }
}

